//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#define SQLExportTempFile "C:\\SQLExp.txt"

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

char gsImportTable[64];

int ProcessCommand(char *ReceivedData, int ReceivedSize)
{
    int FlagLength = 0;
    int FlaggedLength = 0;
    char FlaggedData[MaxReceiveSize + 1];

    if((FlagLength = CompareFlagedString(ReceivedData, "::ImportTable:")))
    {
    	FlaggedLength = GetFlagedValue(ReceivedData, FlagLength, ReceivedSize, FlaggedData);
        FlaggedData[FlaggedLength] = '\0';
        
        strcpy(gsImportTable, FlaggedData);
        return COMMAND_RESULT_OK;
    }
    else if((FlagLength = CompareFlagedString(ReceivedData, "::Statement:")))
    {
        char StatTemp[255];

    	FlaggedLength = GetFlagedValue(ReceivedData, FlagLength, ReceivedSize, FlaggedData);
        FlaggedData[FlaggedLength] = '\0';

        sprintf(StatTemp, "Exporting %s data.", gsImportTable);
        InsertListBoxItem(MDI.RecvEdit_hWnd, StatTemp, -1);

        if(!ExportSQLResults(gsSQLDriver, gsSQLServer, gsSQLUserID, gsSQLPassword, gsSQLDatabase, FlaggedData, gsImportTable, SQLExportTempFile))
        {
            InsertListBoxItem(MDI.RecvEdit_hWnd, "Failed to execute SQL statement:", -1);// FIXME: Need to log this error

            sprintf(StatTemp, "gsSQLDriver: %s", gsSQLDriver);
            InsertListBoxItem(MDI.RecvEdit_hWnd, StatTemp, -1);
            sprintf(StatTemp, "gsSQLServer: %s", gsSQLServer);
            InsertListBoxItem(MDI.RecvEdit_hWnd, StatTemp, -1);
            sprintf(StatTemp, "gsSQLUserID: %s", gsSQLUserID);
            InsertListBoxItem(MDI.RecvEdit_hWnd, StatTemp, -1);
            sprintf(StatTemp, "gsSQLPassword: %s", gsSQLPassword);
            InsertListBoxItem(MDI.RecvEdit_hWnd, StatTemp, -1);
            sprintf(StatTemp, "gsSQLDatabase: %s", gsSQLDatabase);
            InsertListBoxItem(MDI.RecvEdit_hWnd, StatTemp, -1);

            InsertListBoxItem(MDI.RecvEdit_hWnd, FlaggedData, -1);
        }
        else{
            sprintf(FlaggedData, "::FileSize:%d", Get_FileSize(SQLExportTempFile));
            SimpleClientSend(FlaggedData);

            sprintf(FlaggedData, "::FileName:%s", gsImportTable);
            SimpleClientSend(FlaggedData);

            Sleep(1000);

            SendFileData(SQLExportTempFile);
        }

        SimpleClientSend("::RequestNextStatement");
        return COMMAND_RESULT_OK;
    }
    else if((FlagLength = CompareFlagedString(ReceivedData, "::ImportSuccess:")))
    {
    	FlaggedLength = GetFlagedValue(ReceivedData, FlagLength, ReceivedSize, FlaggedData);
        FlaggedData[FlaggedLength] = '\0';
        
        SQLBasics SQL;
        HSTMT UpdateHandle;
        char xStatement[255];

        if(!SQL.DBConnect(gsSQLDriver, gsSQLServer, gsSQLUserID, gsSQLPassword, gsSQLDatabase))
        {
            printf("ImportSuccess DBConnect: Fail.\n");
            return COMMAND_RESULT_ERROR;
        }

        sprintf(xStatement, "UPDATE %s SET Portal_Dirty = 0 WHERE Portal_Dirty = 2", gsImportTable);
        if(!SQL.DBExecute(xStatement, &UpdateHandle))
        {
            SQL.DBCloseCursor(UpdateHandle);
            SQL.DBDisconnect();
            printf("ImportSuccess UPDATE DBexecute: Fail.\n");
            return COMMAND_RESULT_ERROR;
        }
        SQL.DBCloseCursor(UpdateHandle);

        return COMMAND_RESULT_OK;
    }
    else if((FlagLength = CompareFlagedString(ReceivedData, "::ImportFailed:")))
    {
    	FlaggedLength = GetFlagedValue(ReceivedData, FlagLength, ReceivedSize, FlaggedData);
        FlaggedData[FlaggedLength] = '\0';

        InsertListBoxItem(MDI.RecvEdit_hWnd, "SQL data failed to import on server side.", -1);

        SQLBasics SQL;
        HSTMT UpdateHandle;
        char xStatement[255];

        if(!SQL.DBConnect(gsSQLDriver, gsSQLServer, gsSQLUserID, gsSQLPassword, gsSQLDatabase))
        {
            printf("ImportFailed DBConnect: Fail.\n");
            return COMMAND_RESULT_ERROR;
        }

        sprintf(xStatement, "UPDATE %s SET Portal_Dirty = 1 WHERE Portal_Dirty = 2", gsImportTable);
        if(!SQL.DBExecute(xStatement, &UpdateHandle))
        {
            SQL.DBCloseCursor(UpdateHandle);
            SQL.DBDisconnect();
            printf("ImportFailed UPDATE DBexecute: Fail.\n");
            return COMMAND_RESULT_ERROR;
        }
        SQL.DBCloseCursor(UpdateHandle);

        return COMMAND_RESULT_OK;
    }
    else if((FlagLength = CompareFlagedString(ReceivedData, "::Error:")))
    {
    	FlaggedLength = GetFlagedValue(ReceivedData, FlagLength, ReceivedSize, FlaggedData);
        FlaggedData[FlaggedLength] = '\0';

        InsertListBoxItem(MDI.RecvEdit_hWnd, FlaggedData, -1);
        return COMMAND_RESULT_DISCONNECT;
    }
    else if(strcmp(ReceivedData, "::EndOfStatements") == 0)
    {
    	FlaggedLength = GetFlagedValue(ReceivedData, FlagLength, ReceivedSize, FlaggedData);
        FlaggedData[FlaggedLength] = '\0';

        InsertListBoxItem(MDI.RecvEdit_hWnd, "Done!", -1);
        return COMMAND_RESULT_DISCONNECT;
    }

    InsertListBoxItem(MDI.RecvEdit_hWnd, ReceivedData, -1);
	return COMMAND_RESULT_UNKNOWN;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

