////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool ImportSQLResults(char *Driver, char *Server, char *UID, char *PWD, char *Database, char *InFileName)
{
    FILE *SourceHandle = NULL;

    SQLBasics SQL;

    HSTMT StatementHandle;

    SQL.Driver   = Driver;
    SQL.Server   = Server;
    SQL.UID      = UID;
    SQL.PWD      = PWD;
    SQL.Database = Database;

    if(!SQL.DBConnect())
    {
        printf("DBConnect: Fail.\n");
        return false;
    }

    if((SourceHandle = fopen(InFileName, "rb")) == NULL)
    {
        printf("TargetFile: Error.\n");
        SQL.DBDisconnect();
        return false;
    }

    int TotalLengthOfAllColumbNames = 0; // For better memory management;
    int TotalLengthOfAllRowData = 0; // For better memory management
    int ImportTableNameLen = 0;
    SQLSMALLINT ColumnCount = 0;
    SQLINTEGER RowCount = 0;
    char ImportTable[256];

    fread(&ImportTableNameLen, sizeof(ImportTableNameLen), 1, SourceHandle); // Read import table name len
    fread(ImportTable, sizeof(char), ImportTableNameLen, SourceHandle); // Read import table name
    fread(&ColumnCount, sizeof(ColumnCount), 1, SourceHandle); // Read number of columbs
    fread(&RowCount, sizeof(RowCount), 1, SourceHandle);       // Read number of rows

    ImportTable[ImportTableNameLen] = '\0';

    char UniuqeKeyName[5][64]; // Contains the names of the uniuqe columbs
    int UniuqeKeyCol[5];       // Contains the columb position of the uniuqe columbs
    int UniuqeKeysNeeded = 2;  // The ammount of uniuqe keys we have to find
    int UniuqeKeysFound = 0;   // The ammount of uniuqe keys we have found

    sprintf(UniuqeKeyName[0], "OrdNbr");
    sprintf(UniuqeKeyName[1], "CustID");

    char **ColumbNames;
    ColumbNames = (char **) calloc(sizeof(char *), ColumnCount + 1);

    SQLSMALLINT ColNameLen = 0;

    int ColumbPos = 0;
    while(ColumbPos < ColumnCount)
    {
        fread(&ColNameLen, sizeof(ColNameLen), 1, SourceHandle);
        ColumbNames[ColumbPos] = (char *) calloc(sizeof(char), ColNameLen + 1);
        fread(ColumbNames[ColumbPos], sizeof(char), ColNameLen, SourceHandle);
        ColumbNames[ColumbPos][ColNameLen] = '\0';
        TotalLengthOfAllColumbNames = (TotalLengthOfAllColumbNames + ColNameLen);

        // Is this columb one of the uniuqe keys
        if(UniuqeKeysFound < UniuqeKeysNeeded)
        {
            int UniuqeKeyCount = 0;
            while(UniuqeKeyCount < UniuqeKeysNeeded)
            {
                if(strcmpi(UniuqeKeyName[UniuqeKeyCount], ColumbNames[ColumbPos]) == 0)
                {
                    UniuqeKeyCol[UniuqeKeyCount] = ColumbPos;
                    UniuqeKeysFound++;
                }
                UniuqeKeyCount++;
            }
        }

        ColumbPos++;
    }

/* // Debug code
    ColumbPos = 0;
    while(ColumbPos < ColumnCount)
    {
        printf("ColumbNames[%d]:%s\n", ColumbPos, ColumbNames[ColumbPos]);
        ColumbPos++;
    }

    printf("UniuqeKeysFound: %d\n", UniuqeKeysFound);

	int UniuqeKeyCount = 0;
    while(UniuqeKeyCount < UniuqeKeysFound)
    {
        printf("UniuqeKeyCol[%d]:%d\n", UniuqeKeyCount, UniuqeKeyCol[UniuqeKeyCount]);
        UniuqeKeyCount++;
    }
*/

    char **SingleRowData;
    SingleRowData = (char **) calloc(sizeof(char *), ColumnCount + 1);

    SQLINTEGER RowDataLen = 0;

    int RowPos = 0;
    while(RowPos < RowCount)
    {
        int BaseMemoryRequirement = 0;
        TotalLengthOfAllRowData = 0;

        // Get row data
        ColumbPos = 0;
        while(ColumbPos < ColumnCount)
        {
            fread(&RowDataLen, sizeof(RowDataLen), 1, SourceHandle);
            SingleRowData[ColumbPos] = (char *) calloc(sizeof(char), RowDataLen + 1);
            fread(SingleRowData[ColumbPos], sizeof(char), RowDataLen, SourceHandle);
            SingleRowData[ColumbPos][RowDataLen] = '\0';
            TotalLengthOfAllRowData = (TotalLengthOfAllRowData + RowDataLen);
            ColumbPos++;
        }

        BaseMemoryRequirement = ((TotalLengthOfAllColumbNames + TotalLengthOfAllRowData) + (ColumnCount * 5)) + 1024;

        // Work with row data here

//        ColumbPos = 0;
//        while(ColumbPos < ColumnCount)
//        {
//            printf("%s, ", SingleRowData[ColumbPos]);
//            ColumbPos++;
//        }


        char WhereStatement[1024];
        char CheckExistanceStatement[1024];

        // Assemble the where statement from the row data, the uniuqe key names and positions
        if(UniuqeKeysFound > 0)
        {
            // Assemble the where statement
            sprintf(WhereStatement, "WHERE %s = %s", UniuqeKeyName[0], SingleRowData[UniuqeKeyCol[0]]);
        	int UniuqeKeyCount = 1;
            while(UniuqeKeyCount < UniuqeKeysFound)
            {
                strcat(WhereStatement, " AND ");
                strcat(WhereStatement, UniuqeKeyName[UniuqeKeyCount]);
                strcat(WhereStatement, " = ");
                strcat(WhereStatement, SingleRowData[UniuqeKeyCol[UniuqeKeyCount]]);
                UniuqeKeyCount++;
            }

            // Assemble the check existance statement
            sprintf(CheckExistanceStatement, "SELECT %s", UniuqeKeyName[0]);
            strcat(CheckExistanceStatement, " FROM ");
            strcat(CheckExistanceStatement, ImportTable);
            strcat(CheckExistanceStatement, " ");
            strcat(CheckExistanceStatement, WhereStatement);

            //printf("CheckExistanceStatement: %s\n", CheckExistanceStatement);
            //printf("WhereStatement: %s\n", WhereStatement);
        }

        if(!SQL.DBExecute(CheckExistanceStatement, &StatementHandle))
        {
            SQL.DBDisconnect();
            printf("CheckExistanceStatement: Fail.\n");
            return 0;
        }

        SQLINTEGER ReturnedRowCount = 0;
        if(SQLRowCount(StatementHandle, &ReturnedRowCount) != SQL_SUCCESS)
        {
            SQL.DBCloseCursor(&StatementHandle);
            SQL.DBDisconnect();
            printf("SQLRowCount CheckExistanceStatement: Error.\n");
            return 0;
        }

        SQL.DBCloseCursor(&StatementHandle);

        char *ImportStatement = NULL;

        //----------------------------------------------------------------------------------------------
        if(ReturnedRowCount == 0) // Do insert
        {
            ImportStatement = (char *) calloc( sizeof(char), BaseMemoryRequirement + 1);

//            printf("Inserting row %d. Memory: %d\n", RowPos, BaseMemoryRequirement);

            sprintf(ImportStatement, "INSERT INTO %s (", ImportTable);
    
            ColumbPos = 0;
            while(ColumbPos < ColumnCount)
            {
                strcat(ImportStatement, ColumbNames[ColumbPos]);
                if(ColumbPos < ColumnCount - 1)
                {
                    strcat(ImportStatement, ",");
                }
                ColumbPos++;
            }
            strcat(ImportStatement, ") VALUES(");

            ColumbPos = 0;
            while(ColumbPos < ColumnCount)
            {
                strcat(ImportStatement, SingleRowData[ColumbPos]);
                if(ColumbPos < ColumnCount - 1)
                {
                    strcat(ImportStatement, ",");
                }
                ColumbPos++;
            }
            strcat(ImportStatement, ") ");

            printf("%s\n", ImportStatement);
        }
        //----------------------------------------------------------------------------------------------
        else { // Do update
            BaseMemoryRequirement = (BaseMemoryRequirement + strlen(WhereStatement));
            ImportStatement = (char *) calloc( sizeof(char), BaseMemoryRequirement + 1);

//            printf("Updating row %d. Memory: %d\n", RowPos, BaseMemoryRequirement);

            sprintf(ImportStatement, "UPDATE %s SET ", ImportTable);

            ColumbPos = 0;
            while(ColumbPos < ColumnCount)
            {
                strcat(ImportStatement, ColumbNames[ColumbPos]);
                strcat(ImportStatement, "=");
                strcat(ImportStatement, SingleRowData[ColumbPos]);
                if(ColumbPos < ColumnCount - 1)
                {
                    strcat(ImportStatement, ",");
                }
                ColumbPos++;
            }

            strcat(ImportStatement, " ");
            strcat(ImportStatement, WhereStatement);

            printf("%s\n", ImportStatement);
        }

        //----------------------------------------------------------------------------------------------

        if(ImportStatement != NULL)
        {
            if(!SQL.DBExecute(CheckExistanceStatement, &StatementHandle))
            {
                SQL.DBDisconnect();
                printf("CheckExistanceStatement: Fail.\n");
                return 0;
            }

            SQL.DBCloseCursor(&StatementHandle);

            free(ImportStatement);
            ImportStatement = NULL;
        }

        // Free row data
        ColumbPos = 0;
        while(ColumbPos < ColumnCount)
        {
            free(SingleRowData[ColumbPos]);
            SingleRowData[ColumbPos] = NULL;
            ColumbPos++;
        }

        RowPos++;
    }

    SQL.DBDisconnect();
    if(SourceHandle) fclose(SourceHandle);

    return true;
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

